#include "KdWindow.h"

int KdWindow::win_count = 0;
KdWindow* KdWindow::wins[KD_MAX_WINDOW];
KdWindow* KdWindow::del_queue[KD_MAX_WINDOW];
Window KdWindow::win;
int KdWindow::q_r = 0;
int KdWindow::q_w = 0;

int
KdWindow::exec_event(int flag, void* vp)
{
	XEvent* xev;
	KeySym ks;
	int x, y;
	LODRect r;
	LODRectList* full;
	int i;
	int ret;
	KdWindow* w;

	// delete queueν
	while (q_r!=q_w) {
		delete del_queue[q_r++];
		if (q_r==KD_MAX_WINDOW) q_r = 0;
	}
	
	if (win_count==0) {
		return ST_NONE;
	}
	w = wins[win_count - 1];
	xev = (XEvent*)vp;
	ret = ST_NONE;
	switch(flag) {
	case KD_EV_KEY:
		ks = XKeycodeToKeysym(dis, xev->xkey.keycode, 0);
		ret = w->key(ks);
		break;
	case KD_EV_MOUSE:
		x = xev->xbutton.x;
		y = xev->xbutton.y;
		ret = w->mouse(x, y);
		break;
	case KD_EV_EXPOSE:
		full = new LODRectList;
		full->add(0, 0, 640, 400);
		for(i=win_count-1; i>=0; i--) {
			wins[i]->get_rect(&r);
			if (r.is_null()==0) {
				wins[i]->paint(full);
				full->remove_rect(&r);
				if (full->count==0) break;
			}
		}
		delete full;
		break;
	case KD_EV_TIMER:
//		printf("%p [", w);
//		for(i=0; i<win_count; i++) {
//			printf(" %p", wins[i]);
//		}
//		printf(" ]\n");
		ret = w->timer();
		break;
	}
	return ret;
}


int
KdWindow::add_window(KdWindow* win)
{
	LODRect r;
    XEvent ev;

	if (win_count>=KD_MAX_WINDOW) {
//		printf("max win!\n");
		return -1;
	}

	// ٥Ȥեå夹
	while (XCheckMaskEvent(dis, KeyPressMask | ButtonPressMask, &ev));

	wins[win_count++] = win;
	win->init();
	win->get_rect(&r);
	if (r.is_null()==0) {
		win->paint(NULL);
	}
//	printf("added %p parent %p\n", win, win->parent);
	return 0;
}


void
KdWindow::redraw()
{
	LODRect r;
	LODRectList* full;
	int i;

	r.set(0, 0, 640, 400);
	full = new LODRectList;
	full->add(&r);
	for(i=win_count-1; i>=0; i--) {
		wins[i]->get_rect(&r);
		if (r.is_null()==0) {
			wins[i]->paint(full);
			full->remove_rect(&r);
			if (full->count==0) break;
		}
	}
	delete full;
}


int
KdWindow::close_window(KdWindow* win)
{
	int i, num, flag;
	LODRect r;

	// ޤʬƤ˻ĥɥõclose(Ƶˤʤ)
	do {
		flag = 0;
		for(i=0; i<win_count; i++) {
			if (wins[i]->parent==win) {
				close_window(wins[i]);
				flag = 1;
				break;
			}
		}
	} while(flag!=0);

	num = -1;
	for(i=0; i<win_count; i++) {
		if (wins[i]==win) {
			num = i;
			break;
		}
	}
//	printf("close %p parent %p num = %d\n", win, win->parent, num);
	if (num==-1) {
		return 0;
	}
	win->get_rect(&r);
	win->end();
	
	// queueϿ(deleteٱ䡣ΤƤФǽ⤤)
	del_queue[q_w++] = win;
	if (q_w==KD_MAX_WINDOW) q_w = 0;
	
	for(i=num; i<win_count; i++) {
		wins[i] = wins[i+1];
	}
	
	win_count--;

	if (r.is_null()==0) {
		LODRectList* full;

		full = new LODRectList;
		full->add(&r);
		for(i=win_count-1; i>=0; i--) {
			wins[i]->get_rect(&r);
			if (r.is_null()==0) {
				wins[i]->paint(full);
				full->remove_rect(&r);
				if (full->count==0) break;
			}
		}
		delete full;
	}
	return 0;
}


int
KdWindow::ret_window(KdWindow* win, int rint, void* vp)
{
	int i, num;

	num = -1;
	for(i=0; i<win_count; i++) {
		if (wins[i]==win) {
			num = i;
			break;
		}
	}
	if (num==-1) {
		printf("can't find window!\n");
		return -1;  // ʤʤ
	}
	close_window(win);
	return 0;
}


// ΥɥθߤΥåפ֤
void
KdWindow::get_clip(KdWindow* w, LODRectList** l)
{
	LODRect r;
	int i;

	w->get_rect(&r);
	*l = new LODRectList;
	(*l)->add(&r);
	for(i=win_count-1; i>=0 && wins[i]!=w; i--) {
		wins[i]->get_rect(&r);
		if (r.is_null()==0) {
			(*l)->remove_rect(&r);
			if ((*l)->count==0) break;
		}
	}
}


// utility
void
KdWindow::set_clip(GC gc, LODRectList* l)
{
	int i;

	XSetClipMask(dis, gc, None);
	if (l!=NULL && l->count!=0) {
		XRectangle* xr;
		int ret;

		xr = new XRectangle[l->count];
		for(i=0; i<l->count; i++) {
			xr[i].x = l->rects[i]->left;
			xr[i].y = l->rects[i]->top;
			xr[i].width = l->rects[i]->right - l->rects[i]->left;
			xr[i].height = l->rects[i]->bottom - l->rects[i]->top;
		}
		ret = XSetClipRectangles(dis, gc, 0, 0, xr, l->count, Unsorted);
		delete xr;
		switch(ret) {
		case BadAlloc:
			printf("BadAlloc\n");
			break;
		case BadGC:
			printf("BadGC\n");
			break;
		case BadMatch:
			printf("BadMatch\n");
			break;
		case BadValue:
			printf("BadValue\n");
			break;
		}
	}
}



void
KdWindow::get_rect(LODRect* r)
{
	r->set(0, 0, 0, 0);  // NULL rect
}


int
KdWindow::init()
{
	return ST_NONE;
}


int
KdWindow::mouse(int x, int y)
{
	return ST_NONE;
}


int
KdWindow::key(KeySym sym)
{
	return ST_NONE;
}


int
KdWindow::paint(LODRectList* r)
{
	return ST_NONE;
}


int
KdWindow::timer()
{
	return ST_NONE;
}


int
KdWindow::ret(KdWindow* src, int rint, void* ret)
{
	return ST_NONE;
}



int
KdWindow::end()
{
	return ST_NONE;
}


