#ifndef _LODRECT_H
#define _LODRECT_H

#define max(a,b) ((a>b) ? a : b)
#define min(a,b) ((a>b) ? b : a)

class LODRect {
public:
    int top;
    int left;
    int right;
    int bottom;

    LODRect() { top = left = right = bottom = 0; }
    LODRect(int l, int t, int r, int b) {
        top = min(t,b); left = min(l,r); right = max(l,r); bottom = max(t,b);
    }
    LODRect(LODRect* r) {
        top = min(r->top, r->bottom); left = min(r->left, r->right);
        right = max(r->left, r->right); bottom = max(r->top, r->bottom);
    }
    int is_null() { return (top==bottom || right==left) ? 1 : 0; }
    int intersect(LODRect* r);
    int include(LODRect* r);
    int include(int x, int y);
    int contact(LODRect* r);
    void offset(int x, int y) { right += x; left += x; bottom += y; top += y; }
    void copy(LODRect* r) {
        top = min(r->top, r->bottom); left = min(r->left, r->right);
        right = max(r->left, r->right); bottom = max(r->top, r->bottom);
    }
    void set(int l, int t, int r, int b) {
        top = min(t,b); left = min(l,r); right = max(l,r); bottom = max(t,b);
    }
    int can_union(LODRect* r);
    int need_change_y_order(LODRect* r);
	void dump();
};


#endif
