#include "dice.h"
#include "dhm2.h"

#define DICE_ORG_X 55
#define DICE_ORG_Y 18
#define DICE_SIZE_X 4
#define DICE_SIZE_Y 6

int DiceVWin::save = 0;
int DiceVWin::save2 = 0;
int DiceVWin::save3 = 0;

int
DiceVWin::init()
{
	switch (num) {
	case 1:
		x1 = DICE_ORG_X*8;
		y1 = DICE_ORG_Y*8;
		r1 = rand()%6;
		interval = CLOCKS_PER_SEC/50;
//		interval = CLOCKS_PER_SEC;
		d = save;
		step = 0;
		phase = 0;
		count = 0;
		count_max = 20;
		break;
	case 2:
		x1 = DICE_ORG_X*8;
		y1 = (DICE_ORG_Y - DICE_SIZE_Y)*8;
		r1 = rand()%6;
		r2 = rand()%6;
		interval = CLOCKS_PER_SEC/50;
		d = save;
		d2 = save2;
		d3 = save3;
		step = 0;
		phase = 0;
		count = 0;
		count_max = 20;
		break;
	case 3:
		x1 = DICE_ORG_X*8;
		y1 = (DICE_ORG_Y - DICE_SIZE_Y)*8;
		r1 = rand()%6;
		r2 = rand()%6;
		r3 = rand()%6;
		interval = CLOCKS_PER_SEC/50;
		d = save;
		d2 = save2;
		d3 = save3;
		step = 0;
		phase = 0;
		count = 0;
		count_max = 20;
		break;
	}
	return ST_NONE;
}


int
DiceVWin::timer()
{
	int d10, d11, d12, d20, d21, d22, d30, d31, d32;
	LODRectList* l;

	get_clip(parent, &l);
	set_clip(gc, l);
	switch(num) {
	case 1:
		// 
		d10 = (d<2) ? 4+d : d-2;
		d11 = (d==0) ? 5 : d-1;
		d12 = (d==5) ? 0 : d+1;
		
		switch(step) {
		case 0:
			// äȤ줿
			XCopyArea(dis, dice_pm[d10], win, gc, 24, 0, 8, 48, x1, y1);
			XCopyArea(dis, dice_pm[d11], win, gc, 0, 0, 32, 48, x1+8, y1);
			XCopyArea(dis, dice_pm[d], win, gc, 0, 0, 8, 48, x1+40, y1);
			XFlush(dis);
			step++;
			break;
		case 1:
			// 2¤
			XCopyArea(dis, dice_pm[d11], win, gc, 0, 0, 32, 48, x1, y1);
			XCopyArea(dis, dice_pm[d], win, gc, 0, 0, 32, 48, x1+32, y1);
			XFlush(dis);
			step++;
			break;
		case 2:
			// 3ܤ
			XCopyArea(dis, dice_pm[d11], win, gc, 8, 0, 24, 48, x1, y1);
			XCopyArea(dis, dice_pm[d], win, gc, 0, 0, 32, 48, x1+24, y1);
			XCopyArea(dis, dice_pm[d12], win, gc, 0, 0, 8, 48, x1+56, y1);
			XFlush(dis);
			step++;
			break;
		case 3:
			XCopyArea(dis, dice_pm[d11], win, gc, 16, 0, 16, 48, x1, y1);
			XCopyArea(dis, dice_pm[d], win, gc, 0, 0, 32, 48, x1+16, y1);
			XCopyArea(dis, dice_pm[d12], win, gc, 0, 0, 16, 48, x1+48, y1);
			XFlush(dis);
			step = 0;
			count++;
			if (count!=count_max) {
				switch(phase) {
				case 0:
					// ®ž
					d = (save+count)%6;
					break;
				case 1:
					// ®ž
					d = (save+20+count)%6;
					interval = CLOCKS_PER_SEC/50 + count*CLOCKS_PER_SEC/100;
					break;
				case 2:
					// ®ž
					if (d==r1) {
						// ?
						*n1 = save = r1;
						ret_window(this, 0, NULL);
						break;
					}
					d = (save+20+6+count)%6;
					break;
				}
			} else {
				switch(phase) {
				case 0:
					// ®žλ
					d = (save+20+count)%6;
					phase = 1;
					count_max = 6;
					count = 0;
					break;
				case 1:
					// ®ž
					d = (save+count+20+6)%6;
					count_max = 40;
//					interval = CLOCKS_PER_SEC*20/50;
					count = 0;
					phase = 2;
					break;
				case 2:
					// ®ž
					// 㺤
					break;
				}
			}
		}
		break;
	case 2:
		// 
		if (d!=-1) {
			d10 = (d<2) ? 4+d : d-2;
			d11 = (d==0) ? 5 : d-1;
			d12 = (d==5) ? 0 : d+1;
		}
		
		if (d2!=-1) {
			d20 = (d2<2) ? 4+d2 : d2-2;
			d21 = (d2==0) ? 5 : d2-1;
			d22 = (d2==5) ? 0 : d2+1;
		}
		
		switch(step) {
		case 0:
			// äȤ줿
			if (d!=-1) {
				XCopyArea(dis, dice_pm[d10], win, gc, 24, 0, 8, 48, x1, y1);
				XCopyArea(dis, dice_pm[d11], win, gc, 0, 0, 32, 48, x1+8, y1);
				XCopyArea(dis, dice_pm[d], win, gc, 0, 0, 8, 48, x1+40, y1);
			}
			if (d2!=-1) {
				XCopyArea(dis, dice_pm[d20], win, gc, 24, 0, 8, 48, x1, y1+48);
				XCopyArea(dis, dice_pm[d21], win, gc, 0, 0, 32, 48, x1+8, y1+48);
				XCopyArea(dis, dice_pm[d2], win, gc, 0, 0, 8, 48, x1+40, y1+48);
			}
			XFlush(dis);
			step++;
			break;
		case 1:
			// 2¤
			if (d!=-1) {
				XCopyArea(dis, dice_pm[d11], win, gc, 0, 0, 32, 48, x1, y1);
				XCopyArea(dis, dice_pm[d], win, gc, 0, 0, 32, 48, x1+32, y1);
			}
			if (d2!=-1) {
				XCopyArea(dis, dice_pm[d21], win, gc, 0, 0, 32, 48, x1, y1+48);
				XCopyArea(dis, dice_pm[d2], win, gc, 0, 0, 32, 48, x1+32, y1+48);
			}
			XFlush(dis);
			step++;
			break;
		case 2:
			// 3ܤ
			if (d!=-1) {
				XCopyArea(dis, dice_pm[d11], win, gc, 8, 0, 24, 48, x1, y1);
				XCopyArea(dis, dice_pm[d], win, gc, 0, 0, 32, 48, x1+24, y1);
				XCopyArea(dis, dice_pm[d12], win, gc, 0, 0, 8, 48, x1+56, y1);
			}
			if (d2!=-1) {
				XCopyArea(dis, dice_pm[d21], win, gc, 8, 0, 24, 48, x1, y1+48);
				XCopyArea(dis, dice_pm[d2], win, gc, 0, 0, 32, 48, x1+24, y1+48);
				XCopyArea(dis, dice_pm[d22], win, gc, 0, 0, 8, 48, x1+56, y1+48);
			}
			XFlush(dis);
			step++;
			break;
		case 3:
			if (d!=-1) {
				XCopyArea(dis, dice_pm[d11], win, gc, 16, 0, 16, 48, x1, y1);
				XCopyArea(dis, dice_pm[d], win, gc, 0, 0, 32, 48, x1+16, y1);
				XCopyArea(dis, dice_pm[d12], win, gc, 0, 0, 16, 48, x1+48,y1);
			}
			if (d2!=-1) {
				XCopyArea(dis, dice_pm[d21],win, gc, 16, 0, 16, 48, x1, y1+48);
				XCopyArea(dis, dice_pm[d2], win, gc, 0, 0, 32, 48, x1+16, y1+48);
				XCopyArea(dis, dice_pm[d22],win, gc, 0, 0, 16, 48, x1+48, y1+48);
			}
			XFlush(dis);
			step = 0;
			count++;
			if (count!=count_max) {
				switch(phase) {
				case 0:
					// ®ž
					d = (save+count)%6;
					d2 = (save2+count)%6;
					break;
				case 1:
					// ®ž
					d = (save+20+count)%6;
					d2 = (save2+20+count)%6;
					interval = CLOCKS_PER_SEC/50 + count*CLOCKS_PER_SEC/100;
					break;
				case 2:
					// ®ž
					if (d==r1) {
						// ?
						d = -1;
					} else {
						if (d!=-1) d = (save+20+6+count)%6;
					}
					if (d2==r2) {
						d2 = -1;
					} else {
						if (d2!=-1) d2 = (save2+20+6+count)%6;
					}
					if (d==-1 && d2==-1) {
						*n1 = save = r1;
						*n2 = save2 = r2;
						ret_window(this, 0, NULL);
					}
					break;
				}
			} else {
				switch(phase) {
				case 0:
					// ®žλ
					d = (save+20+count)%6;
					d2 = (save2+20+count)%6;
					phase = 1;
					count_max = 6;
					count = 0;
					break;
				case 1:
					// ®ž
					d = (save+count+20+6)%6;
					d2 = (save2+count+20+6)%6;
					count_max = 40;
//					interval = CLOCKS_PER_SEC*20/50;
					count = 0;
					phase = 2;
					break;
				case 2:
					// ®ž
					// 㺤
					break;
				}
			}
		}
		break;
	case 3:
		// 
		if (d!=-1) {
			d10 = (d<2) ? 4+d : d-2;
			d11 = (d==0) ? 5 : d-1;
			d12 = (d==5) ? 0 : d+1;
		}
		
		if (d2!=-1) {
			d20 = (d2<2) ? 4+d2 : d2-2;
			d21 = (d2==0) ? 5 : d2-1;
			d22 = (d2==5) ? 0 : d2+1;
		}
		
		if (d3!=-1) {
			d30 = (d3<2) ? 4+d3 : d3-2;
			d31 = (d3==0) ? 5 : d3-1;
			d32 = (d3==5) ? 0 : d3+1;
		}
		
		switch(step) {
		case 0:
			// äȤ줿
			if (d!=-1) {
				XCopyArea(dis, dice_pm[d10], win, gc, 24, 0, 8, 48, x1, y1);
				XCopyArea(dis, dice_pm[d11], win, gc, 0, 0, 32, 48, x1+8, y1);
				XCopyArea(dis, dice_pm[d], win, gc, 0, 0, 8, 48, x1+40, y1);
			}
			if (d2!=-1) {
				XCopyArea(dis, dice_pm[d20], win, gc, 24, 0, 8, 48, x1, y1+48);
				XCopyArea(dis, dice_pm[d21], win, gc, 0, 0, 32, 48, x1+8, y1+48);
				XCopyArea(dis, dice_pm[d2], win, gc, 0, 0, 8, 48, x1+40, y1+48);
			}
			if (d3!=-1) {
				XCopyArea(dis, dice_pm[d30], win, gc, 24, 0, 8, 48, x1, y1+48*2);
				XCopyArea(dis, dice_pm[d31], win, gc, 0, 0, 32, 48, x1+8, y1+48*2);
				XCopyArea(dis, dice_pm[d3], win, gc, 0, 0, 8, 48, x1+40, y1+48*2);
			}
			XFlush(dis);
			step++;
			break;
		case 1:
			// 2¤
			if (d!=-1) {
				XCopyArea(dis, dice_pm[d11], win, gc, 0, 0, 32, 48, x1, y1);
				XCopyArea(dis, dice_pm[d], win, gc, 0, 0, 32, 48, x1+32, y1);
			}
			if (d2!=-1) {
				XCopyArea(dis, dice_pm[d21], win, gc, 0, 0, 32, 48, x1, y1+48);
				XCopyArea(dis, dice_pm[d2], win, gc, 0, 0, 32, 48, x1+32, y1+48);
			}
			if (d3!=-1) {
				XCopyArea(dis, dice_pm[d31], win, gc, 0, 0, 32, 48, x1, y1+48*2);
				XCopyArea(dis, dice_pm[d3], win, gc, 0, 0, 32, 48, x1+32, y1+48*2);
			}
			XFlush(dis);
			step++;
			break;
		case 2:
			// 3ܤ
			if (d!=-1) {
				XCopyArea(dis, dice_pm[d11], win, gc, 8, 0, 24, 48, x1, y1);
				XCopyArea(dis, dice_pm[d], win, gc, 0, 0, 32, 48, x1+24, y1);
				XCopyArea(dis, dice_pm[d12], win, gc, 0, 0, 8, 48, x1+56, y1);
			}
			if (d2!=-1) {
				XCopyArea(dis, dice_pm[d21], win, gc, 8, 0, 24, 48, x1, y1+48);
				XCopyArea(dis, dice_pm[d2], win, gc, 0, 0, 32, 48, x1+24, y1+48);
				XCopyArea(dis, dice_pm[d22], win, gc, 0, 0, 8, 48, x1+56, y1+48);
			}
			if (d3!=-1) {
				XCopyArea(dis, dice_pm[d31], win, gc, 8, 0, 24, 48, x1, y1+48*2);
				XCopyArea(dis, dice_pm[d3], win, gc, 0, 0, 32, 48, x1+24, y1+48*2);
				XCopyArea(dis, dice_pm[d32], win, gc, 0, 0, 8, 48, x1+56, y1+48*2);
			}
			XFlush(dis);
			step++;
			break;
		case 3:
			if (d!=-1) {
				XCopyArea(dis, dice_pm[d11], win, gc, 16, 0, 16, 48, x1, y1);
				XCopyArea(dis, dice_pm[d], win, gc, 0, 0, 32, 48, x1+16, y1);
				XCopyArea(dis, dice_pm[d12], win, gc, 0, 0, 16, 48, x1+48,y1);
			}
			if (d2!=-1) {
				XCopyArea(dis, dice_pm[d21],win, gc, 16, 0, 16, 48, x1, y1+48);
				XCopyArea(dis, dice_pm[d2], win, gc, 0, 0, 32, 48, x1+16, y1+48);
				XCopyArea(dis, dice_pm[d22],win, gc, 0, 0, 16, 48, x1+48, y1+48);
			}
			if (d3!=-1) {
				XCopyArea(dis, dice_pm[d31],win, gc, 16, 0, 16, 48, x1, y1+48*2);
				XCopyArea(dis, dice_pm[d3], win, gc, 0, 0, 32, 48, x1+16, y1+48*2);
				XCopyArea(dis, dice_pm[d32],win, gc, 0, 0, 16, 48, x1+48, y1+48*2);
			}
			XFlush(dis);
			step = 0;
			count++;
			if (count!=count_max) {
				switch(phase) {
				case 0:
					// ®ž
					d = (save+count)%6;
					d2 = (save2+count)%6;
					d2 = (save3+count)%6;
					break;
				case 1:
					// ®ž
					d = (save+20+count)%6;
					d2 = (save2+20+count)%6;
					d3 = (save3+20+count)%6;
					interval = CLOCKS_PER_SEC/50 + count*CLOCKS_PER_SEC/100;
					break;
				case 2:
					// ®ž
					if (d==r1) {
						// ?
						d = -1;
					} else {
						if (d!=-1) d = (save+20+6+count)%6;
					}
					if (d2==r2) {
						d2 = -1;
					} else {
						if (d2!=-1) d2 = (save2+20+6+count)%6;
					}
					if (d3==r3) {
						d3 = -1;
					} else {
						if (d3!=-1) d3 = (save3+20+6+count)%6;
					}
					if (d==-1 && d2==-1 && d3==-1) {
						*n1 = save = r1;
						*n2 = save2 = r2;
						*n3 = save3 = r3;
						ret_window(this, 0, NULL);
					}
					break;
				}
			} else {
				switch(phase) {
				case 0:
					// ®žλ
					d = (save+20+count)%6;
					d2 = (save2+20+count)%6;
					d3 = (save3+20+count)%6;
					phase = 1;
					count_max = 6;
					count = 0;
					break;
				case 1:
					// ®ž
					d = (save+count+20+6)%6;
					d2 = (save2+count+20+6)%6;
					d3 = (save2+count+20+6)%6;
					count_max = 40;
//					interval = CLOCKS_PER_SEC*20/50;
					count = 0;
					phase = 2;
					break;
				case 2:
					// ®ž
					// 㺤
					break;
				}
			}
		}
		break;
	}
	set_clip(gc, NULL);
	delete l;
//	ppi();
	return ST_NONE;
}


