// ν == ܿͤζ

#include <stdio.h>
#include "kanji.h"

int gSysKcode  = EUC;  // 
int gDispKcode = EUC;  // ɽ

#define	SS2	0x8E			/* for EUC half kana */
#define	ESC	0x1b
#define	NON	0
#define	NOKANJI	0

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif
#ifndef NULL
#define NULL 0
#endif


static void sjistojis(char *src, char *dst);
static void jistosjis(char *src, char *dst);
static void euctosjis(char *src, char *dst);
static void sjistoeuc(char *src, char *dst);
static void euctojis(char *src, char *dst);
static void jistoeuc(char *src, char *dst);
static void notconv(char *src, char *dst);

int isKanji(int c, int code)
{
   c = (c & 0xff);
   if(code == SJIS) {
	 if((0x80 < c && c < 0xa0) || (0xe0 <= c && c <= 0xfc)) return 1;
   }
   else if(code == EUC) {
	 if(0xa0 < c && c < 0xff) return 1;
	 if(c == 0x8e) return 1;
   }
   else if(code == JIS) {
	 if(0x20 < c && c < 0x7f) return 1;
   }
   return 0;
}


int isKanji2nd(char *str, int col)
{
  int	j;
  
  if(!col || !iskanji(str[col-1]))	return 0;
  for( j=0 ; j < col ; j++ ) {
	if (iskanji(str[j]))	j++;
  }
  if( j == col ) {
	return 0;
  } else {
	return 1;
  }
}




int isKanji2nd(unsigned short *str, int col)
{
  int	j;
  
  if(!col || !iskanji(str[col-1]&0xff))	return 0;
  for( j=0 ; j < col ; j++ ) {
	if (iskanji(str[j]&0xff))	j++;
  }
  if( j == col ) {
	return 0;
  } else {
	return 1;
  }
}




#define	ISMARU(c)	(0xca <= (c & 0xff) && (c & 0xff) <= 0xce)
#define ISNIGORI(c)	((0xb6 <= (c & 0xff) && (c & 0xff) <= 0xc4)\
			|| (0xca <= (c & 0xff) && (c & 0xff) <= 0xce)\
			|| (0xb3 == (c & 0xff)))
// ȾѴ(ϤSJIS only)
static void han2zen(unsigned char* in, unsigned char* out,
					int* lin, int* lout, int code)
{
	int	maru = FALSE;
	int nigori = FALSE;
	unsigned char ch1, ch2 = '\0';
	static int mtable[][2] = {
	  {129,66},{129,117},{129,118},{129,65},{129,69},{131,146},{131,64},
	  {131,66},{131,68},{131,70},{131,72},{131,131},{131,133},{131,135},
	  {131,98},{129,91},{131,65},{131,67},{131,69},{131,71},{131,73},
	  {131,74},{131,76},{131,78},{131,80},{131,82},{131,84},{131,86},{131,88},
	  {131,90},{131,92},{131,94},{131,96},{131,99},{131,101},{131,103},
	  {131,105},{131,106},{131,107},{131,108},{131,109},{131,110},{131,113},
	  {131,116},{131,119},{131,122},{131,125},{131,126},{131,128},{131,129},
	  {131,130},{131,132},{131,134},{131,136},{131,137},{131,138},{131,139},
	  {131,140},{131,141},{131,143},{131,147},{129,74},{129,75}
	};
	
	if(code==EUC) {
	  ch1 = in[1];
	  if(in[2]==SS2) ch2 = in[3];
	}
	else if(code==JIS) {
	  ch1 = (in[0] | 0x80);
	  ch2 = (in[1] | 0x80);
	}
	else {
	  ch1 = in[0];
	  ch2 = in[1];
	}

	if(ch1==0xa0) {
	  out[0] = ' ';
	  out[1] = '\0';
	  *lin = *lout = 1;
	  if(code==EUC) *lin = 2;
	} else {
	  if(ch2 == 0xde && ISNIGORI(ch1)) {
		nigori = TRUE;
	  }
	  else if(ch2 == 0xdf && ISMARU(ch1)) {
		maru = TRUE;
	  }
	  out[0] = mtable[ch1 - 0xa1][0];
	  out[1] = mtable[ch1 - 0xa1][1];
	  if(nigori) {
		if((0x4a <= out[1] && out[1] <= 0x67)
		   || (0x6e <= out[1] && out[1] <= 0x7a)) {
		  out[1]++;
		}
		else if(out[0] == 0x83 && out[1] == 0x45) {
		  out[1] = 0x94;
		}
	  }
	  else if(maru && 0x6e <= out[1] && out[1] <= 0x7a) {
		out[1] += 2;
	  }
	  
	  if(nigori || maru) {
		*lin = 2;
	  } else {
		*lin = 1;
	  }
	  if(code==EUC) *lin *= 2;
	  *lout = 2;
	}
}

static void sjistojis(char *src, char *dst)
{
   sjistoeuc(src, dst);
   *dst++ &= 0x7f;
   *dst &= 0x7f;
}


static void jistosjis(char *src, char *dst)
{
   int	high;
   int	low;
	
   high = *src & 0x7f;
   low = *(src+1) & 0x7f;
   if (high & 1) {
     low += 0x1f;
   } else {
     low += 0x7d;
   }
   if (low >= 0x7f) low++;
   high = ((high - 0x21) >> 1) + 0x81;
   if (high > 0x9f) high += 0x40;
   *dst = (char)high;
   *(dst+1) = (char)low;
}


static void euctosjis(char *src, char *dst)
{
   euctojis(src, dst);
   jistosjis(dst, dst);
}

static void sjistoeuc(char *src, char *dst)
{
   unsigned int	high;
   unsigned int	low;
	
   high = *src & 0xff;
   low = *(src+1) & 0xff;
   if (high <= 0x9f) {
     high -= 0x71;
   } else {
     high -= 0xb1;
   }
   high = high * 2 + 1;
   if (low > 0x7f) low--;
   if (low >= 0x9e) {
	 low -= 0x7d;
	 high++;
   } else {
	 low -= 0x1f;
   }
   
   *dst = (char)(high | 0x80);
   *(dst+1) = (char)(low | 0x80);
}


static void euctojis(char *src, char *dst)
{
   *dst = *src & 0x7f;
   *(dst+1) = *(src+1) & 0x7f;
}


static void jistoeuc(char *src, char *dst)
{
   *dst = (*src | 0x80);
   *(dst+1) = (*(src+1) | 0x80);
}


static void notconv(char *src, char *dst)
{
   *dst = *src;
   *(dst+1) = *(src+1);
}



static void (*codeconv[NCODE][NCODE])(char*, char*) = {
  {notconv, notconv,   notconv,   notconv},
  {notconv, notconv,   euctojis,  euctosjis},
  {notconv, jistoeuc,  notconv,   jistosjis},
  {notconv, sjistoeuc, sjistojis, notconv}
};


// ѴΥХåեĹ֤
static int checkLen(unsigned char* src,
					int n,
					int incode, int outcode, int htoz)
{
	int	i, size=0;
	int	kflg  = FALSE, hflg = FALSE;
	int	okflg = FALSE, ohflg = FALSE;


	for(i=0 ; i<n ; ) {
	  if(incode == JIS && src[i] == ESC ) {
		// JISץ󥹤ν
		if(src[i+1] == '$') {
		  if((src[i+2] == '@') || (src[i+2] == 'B')) {
			i += 3;
			kflg = TRUE;
			hflg = FALSE;
		  } else {
			i += 2;
			size += 2;
		  }
		}
		else if(src[i+1] == '(') {
		  if((src[i+2] == 'J') || (src[i+2] == 'B') || (src[i+2] == 'H')) {
			i += 3;
			kflg = hflg = FALSE;
		  }
		  else if(src[i+2] == 'I') {
			i += 3;
			kflg = FALSE;
			hflg = TRUE;
		  }
		  else {
			i += 2;
			size += 2;
		  }
		}
		else {
		  i++;
		  size++;
		}
	  }
	  else if((incode==JIS && kflg && isjiskanji(src[i]))
			  || (incode==EUC && iseuckanji(src[i]))
			  || (incode==SJIS && issjiskanji(src[i]))) {
		// ν
		i += 2;
		size += 2;
		if(outcode==JIS && !okflg) {
		  size += 3;
		  okflg = TRUE;
		  ohflg = FALSE;
		}
	  }
	  else if((incode==JIS && hflg)
			  || (incode==EUC && src[i]==SS2)
			  || (incode==SJIS && ishkana(src[i]))) {
		// Ⱦѥʤν
		if(htoz) {
		  int	sc, dc;
		  unsigned char p[2];
		  
		  han2zen(&src[i], p, &sc, &dc, incode);
		  i    += sc;
		  size += dc;
		  if(outcode==JIS && !okflg) {
			size += 3;
			okflg = TRUE;
			ohflg = FALSE;
		  }
		} else {
		  i++; size++;
		  if(incode==EUC)	i++;
		  if(outcode==EUC)	size++;
		  if(outcode==JIS && !ohflg) {
			size += 3;
			okflg = FALSE;
			ohflg = TRUE;
		  }
		}
	  }
	  else {
		i++;
		size++;
		if(outcode==JIS && (okflg || ohflg)) {
		  size += 3;
		  okflg = ohflg = FALSE;
		}
	  }
	}
	
	if(outcode==JIS && (okflg || ohflg)) {
	  size += 3;
	  okflg = ohflg = FALSE;
	}
	
	return size;
}


unsigned char * kcodeConv(unsigned char* src, int* size,
						  int incode, int outcode,
						  int hantozen)
{
   int	dstsize;
   unsigned char*dst;
   static int	kflg = FALSE, hflg = FALSE;
   static int	okflg = FALSE, ohflg = FALSE;
   static char kanji_char[2] = {'\0', '\0'};
   int		i, o;
   void	(*kcodeto)(char *, char *);
   void	(*kanakcodeto)(char *, char *);
   char	*jiskanji = "\033$B",
	*jiskana = "\033(I",
	*jisascii = "\033(B";

   if(gSysKcode==ASCII || src==ASCII) return src;
   // Ф˥ԡϤ
#if 0
   if(incode == outcode) {
	 if(!hantozen) return src;
   }
#endif
   kcodeto     = codeconv[incode][outcode];
   kanakcodeto = codeconv[SJIS][outcode];

   dstsize = checkLen(src, *size, incode, outcode, hantozen);
   if(kanji_char[0]) {
	 dstsize++;
	 if(outcode==JIS) dstsize += 3;
   }
   if((dst = (unsigned char*)new unsigned char[dstsize + 1])==NULL) {
	 /* error message */
	 return	src;
   }

   for(i=0,o=0 ; i<*size ; ) {
	 if(incode==JIS && src[i]==ESC) {
	   // JISץ󥹤ν
	     if(src[i+1] == '$') {
		   if((src[i+2] == '@') || (src[i+2] == 'B')) {
			 i += 3;
			 kflg = TRUE;
			 hflg = FALSE;
		   } else {
			 dst[o++] = src[i++];
		   }
		 }
	     else if(src[i+1] == '(') {
		   if((src[i+2] == 'J') || (src[i+2] == 'B')) {
			 i += 3;
			 kflg = hflg = FALSE;
		   }
		   else if(src[i+2] == 'I') {
			 i += 3;
			 kflg = FALSE;
			 hflg = TRUE;
		   }
		   else {
		     dst[o++] = src[i++];
		   }
		 }
	     else {
		   dst[o++] = src[i++];
		 }
	 }
	 else if((incode==JIS && kflg && isjiskanji(src[i]))
			 || (incode==EUC && iseuckanji(src[i]))
			 || (incode==SJIS && issjiskanji(src[i]))
			 || kanji_char[0]) {
	   // ɤν
	   if(i==(*size-1) && !kanji_char[0]) {
		 // Ǹ1ХȤκǽä硢
		 // static˥ɤ򥻥åȤƤƼ
		 kanji_char[0] = src[i];
		 i++;
	   } else {
		 // 
		 if(outcode == JIS && !okflg) {
		   // JISä饷եȤ
		   strcpy((char*)&dst[o], jiskanji);
		   o += strlen(jiskanji);
		   okflg = TRUE;
		   ohflg = FALSE;
		 }
		 if(kanji_char[0]) {
		   // λĤ꤬
		   kanji_char[1] = src[i];
		   kcodeto((char*)kanji_char, (char*)&dst[o]);
		   kanji_char[0] = '\0';
		   i--;
		 } else {
		   // ̤Ѵ
		   kcodeto((char*)&src[i], (char*)&dst[o]);
		 }
		 i += 2;
		 o += 2;
	   }
	 }
	 else if((incode==JIS && hflg)
			 || (incode==EUC && src[i] == SS2)
			 || (incode==SJIS && ishkana(src[i]))) {
	   // Ⱦѥʤν
	   if(hantozen) {
		 int sc, dc;
		 
		 if(outcode==JIS && !okflg) {
		   strcpy((char*)&dst[o], jiskanji);
		   o += strlen(jiskanji);
		   okflg = TRUE;
		   ohflg = FALSE;
		 }
		 han2zen(&src[i], &dst[o], &sc, &dc, incode);
		 kanakcodeto((char*)&dst[o], (char*)&dst[o]);
		 i += sc;
		 o += dc;
	   } else {
		 if (outcode == JIS && !ohflg) {
		   strcpy((char*)&dst[o], jiskana);
		   o += strlen(jiskana);
		   okflg = FALSE;
		   ohflg = TRUE;
		 }
		 if (incode==EUC) i++;
		 if (outcode==EUC) dst[o++] = SS2;
		 dst[o]=src[i];
		 if (outcode==JIS) {
		   dst[o] &= 0x7f;
		 } else {
		   dst[o] |= 0x80;
		 }
		 i++;
		 o++;
	   }
	 }
	 else {
	   if(outcode == JIS && (okflg || ohflg)) {
		 strcpy((char*)&dst[o], jisascii);
		 o += strlen(jisascii);
		 okflg = ohflg = FALSE;
	   }
	   dst[o++] = src[i++];
	 }
   }
   
   dst[o] = '\0';
   *size = o;

   return dst;
}


// *size = ΥͤϽǤ
unsigned char*
kcodeConvFilter(unsigned char* src,
				int* size,
				int incode, int outcode,
				int	*kflg,  int *hflg,
				int	*okflg, int *ohflg,
				int hantozen)
{
   int	dstsize;
   unsigned char*dst;
   int i, o;
   void	(*kcodeto)(char *, char *);
   void	(*kanakcodeto)(char *, char *);
   char	*jiskanji = "\033$B",
   *jiskana = "\033(I",
   *jisascii = "\033(B";
   
   if(gSysKcode==ASCII || src==ASCII) return src;
   if(incode == outcode) {
	   if(!hantozen) return src;
   }
   kcodeto     = codeconv[incode][outcode];
   kanakcodeto = codeconv[SJIS][outcode];
   
   dstsize = checkLen(src, *size, incode, outcode, hantozen);
   if((dst = (unsigned char*)new unsigned char[dstsize + 1])==NULL) {
	   /* error message */
	   return	src;
   }
   
   for(i=0,o=0 ; i<*size ; ) {
	   if(incode==JIS && src[i]==ESC) {
		   // JISץ󥹤ν
		   if(i+1 < *size && src[i+1] == '$') {
			   if(i+2<*size && (src[i+2] == '@') || (src[i+2] == 'B')) {
				   i += 3;
				   *kflg = TRUE;
				   *hflg = FALSE;
			   }
			   else if (i+2>=*size) {
				   // ­ʤȽǽ
				   break;
			   }
			   else {
				   dst[o++] = src[i++];
			   }
		   }
		   else if(i+1<*size && src[i+1] == '(') {
			   if(i+2<*size && (src[i+2] == 'J') || (src[i+2] == 'B')) {
				   i += 3;
				   *kflg = *hflg = FALSE;
			   }
			   else if(i+2<*size && src[i+2] == 'I') {
				   i += 3;
				   *kflg = FALSE;
				   *hflg = TRUE;
			   }
			   else if (i+2>=*size) {
				   // ­ʤȽǽ
				   break;
			   }
			   else {
				   dst[o++] = src[i++];
			   }
		   }
		   else if (i+1>=*size) {
			   // ­ʤȽǽ
			   break;
		   }
		   else {
			   dst[o++] = src[i++];
		   }
	   }
	   else if((incode==JIS && *kflg && isjiskanji(src[i]))
			   || (incode==EUC && iseuckanji(src[i]))
			   || (incode==SJIS && issjiskanji(src[i]))) {
		   // ɤν
		   if(i==(*size-1)) {
			   // Ǹ1ХȤκǽä硢
			   break;
		   } else {
			   // 
			   if(outcode == JIS && !*okflg) {
				   // JISä饷եȤ
				   strcpy((char*)&dst[o], jiskanji);
				   o += strlen(jiskanji);
				   *okflg = TRUE;
				   *ohflg = FALSE;
			   }
			   // ̤Ѵ
			   kcodeto((char*)&src[i], (char*)&dst[o]);
			   i += 2;
			   o += 2;
		   }
	   }
	   else if((incode==JIS && *hflg)
			   || (incode==EUC && src[i] == SS2)
			   || (incode==SJIS && ishkana(src[i]))) {
		   // Ⱦѥʤν
		   if(hantozen) {
			   int sc, dc;
			   
			   if(outcode==JIS && !*okflg) {
				   strcpy((char*)&dst[o], jiskanji);
				   o += strlen(jiskanji);
				   *okflg = TRUE;
				   *ohflg = FALSE;
			   }
			   han2zen(&src[i], &dst[o], &sc, &dc, incode);
			   kanakcodeto((char*)&dst[o], (char*)&dst[o]);
			   i += sc;
			   o += dc;
		   } else {
			   if (outcode == JIS && !*ohflg) {
				   strcpy((char*)&dst[o], jiskana);
				   o += strlen(jiskana);
				   *okflg = FALSE;
				   *ohflg = TRUE;
			   }
			   if (incode==EUC) i++;
			   if (outcode==EUC) dst[o++] = SS2;
			   dst[o]=src[i];
			   if (outcode==JIS) {
				   dst[o] &= 0x7f;
			   } else {
				   dst[o] |= 0x80;
			   }
			   i++;
			   o++;
		   }
	   }
	   else {
		   if(outcode == JIS && (*okflg || *ohflg)) {
			   strcpy((char*)&dst[o], jisascii);
			   o += strlen(jisascii);
			   *okflg = *ohflg = FALSE;
		   }
		   dst[o++] = src[i++];
	   }
   }
   
   if(outcode==JIS && (*okflg || *ohflg)) {
	   strcpy((char*)&dst[o], jisascii);
	   o += strlen(jisascii);
	   *okflg = *ohflg = FALSE;
   }
   
   dst[o] = '\0';
   *size = i;
   
   return dst;
}



// 르ꥺܸ(̾)ΤΤѹ
int	codeDetect(unsigned char* buf, int len)
{
	int	code=ASCII;
	int	i, c;
	int EightBit = 0;
	
	for(i=0 ; code==ASCII && i<len; ) {
		c = buf[i++];
		if (EightBit==0 && c==ESC) {
			if (i<len) {
				c = buf[i++];
				if (c=='$' && i<len) {
					c = buf[i++];
					if (c=='B') return JIS;  // JIS
					if (c=='@') return JIS;  // JIS
				}
			}
		}
		else if ((c & 0x80)==0) continue;
		else {
			EightBit = 1;
			if ((c>=129 && c<=141) || (c>=143 && c<=159)) return SJIS;
			else if (c==SS2) {
				if (i<len) {
					c = buf[i++];
					if ((c>=64 && c<=126) || (c>=128 && c<=160)
						|| (c>=224 && c<=252)) {
						return SJIS;
					}
				}
			}
			else if (c>=161 && c<=254) {
				if (i<len) {
					c = buf[i++];
					if (c>=240 && c<=254) return EUC;
					else if (c>=161 && c<=223) continue;  // ̤
					else if (c>=224 && c<=239) {  // ̤
						while(c>=64 && i<len) {
							if (c>=129) {
								if (c<=141 || (c>=143 && c<=159)) return SJIS;
								else if (c>=253 && c<=254) return EUC;
							}
							c = buf[i++];
						}
					}
				}
			}
			else if (c<=159) return SJIS;
			else if (c>=240 && c<=254) return EUC;
			else if (c>=224 && c<=239) {
				if (i<len) {
					c = buf[i++];
					if ((c>=64 && c<=126) || (c>=128 && c<=160)) return SJIS;
					else if (c>=253 && c<=254) return EUC;
				}
			}
		}
	}
	return ASCII;
}

