#ifndef _KANJI_H
#define _KANJI_H

#include <string.h>

#define NCODE   4
#define ASCII	0
#define	EUC	    1
#define	JIS 	2
#define	SJIS	3

extern int gSysKcode;   // 
extern int gDispKcode;  // ɽ

extern int isKanji(int, int);
extern int isKanji2nd(char *, int);
extern int isKanji2nd(unsigned short *, int);
extern unsigned char * kcodeConv(unsigned char* src, int* size,
								 int incode, int outcode,
								 int hantozen);
								 
extern unsigned char* kcodeConvFilter(unsigned char* src,
									  int* size,
									  int incode, int outcode,
									  int *kflg,  int *hflg,
									  int *okflg, int *ohflg,
									  int hantozen);
				
extern int codeDetect(unsigned char* buf, int len);

#define iskanji(c)	isKanji(c,gSysKcode)
#define iskanji2nd(s, n)	isKanji2nd(s, n)

int inline issjiskanji(int c)
{
  if ((0x81 <= (unsigned char)(c&0xff)
	   && (unsigned char)(c&0xff) <= 0x9f)
	  || (0xe0 <= (unsigned char)(c&0xff)
		  && (unsigned char)(c&0xff) <= 0xfc)) {
	return 1;
  } else {
	return 0;
  }
}


int inline iseuckanji(int c)
{
  if (0xa1 <= (unsigned char)(c&0xff) && (unsigned char)(c&0xff) <= 0xfe) {
	return 1;
  } else {
	return 0;
  }
}



int inline isjiskanji(int c)
{
  if (0x21 <= (unsigned char)(c&0xff) && (unsigned char)(c&0xff) <= 0x7e) {
	return 1;
  } else {
	return 0;
  }
}



int inline ishkana(int c)
{
  if (0xa0 <= (unsigned char)(c&0xff) && (unsigned char)(c&0xff) <= 0xdf) {
	return 1;
  } else {
	return 0;
  }
}

int inline issjis2ndkanji(int c)
{
	if ((0x40 <= (unsigned char)(c&0xff)
		 &&
		 (unsigned char)(c&0xff) <= 0x7e)
		||
		(0x80 <= (unsigned char)(c&0xff)
		 &&
		 (unsigned char)(c&0xff) <= 0xfc)) {
		return 1;
	} else {
		return 0;
	}
}


#endif
